package org.jworkplace.login;

import java.security.Principal;


public class WorkPlacePrincipal implements Principal, java.io.Serializable {
    private String name;

    public WorkPlacePrincipal(String name) {
        if (name == null) {
            throw new NullPointerException("illegal null input");
        }

        this.name = name;
    }

    public String getName() {
        return name;
    }

    public String toString() {
        return ("WorkPlacePrincipal: " + name);
    }

    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }

        if (this == o) {
            return true;
        }

        if (!(o instanceof WorkPlacePrincipal)) {
            return false;
        }

        WorkPlacePrincipal that = (WorkPlacePrincipal) o;

        if (this.getName().equals(that.getName())) {
            return true;
        }

        return false;
    }

    public int hashCode() {
        return name.hashCode();
    }
}