
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;

public class AgentService extends UnicastRemoteObject
                           implements Agent
{
    public AgentService() throws RemoteException {
        super();
    }


    public static void main(String[] args) {
        if(args.length < 1) {
            System.out.println("usage [hostname]");
            System.exit(1);
        }

        String hostname = args[0];

        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }

        String name = "//" + hostname + "/Agent";

        try {
            Agent agent = new AgentService();
            Naming.rebind(name, agent);
            System.out.println("AgentService bound");
        } catch (Exception e) {
            System.err.println("AgentService exception: " + 
          e.getMessage());
            e.printStackTrace();
        }
    }

    // implementation of the Agent interface
    public String talk() {
        return "P2P is very cool";
    }

}

