import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.rmi.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import net.jini.space.JavaSpace;

public class ChatFrame extends JFrame {

   public static void main(String[] args) {
       if(args.length < 4) {
          System.out.println("Usage [hostname] [spacename] [channel] [user]");
          System.exit(1);
       }
       ChatFrame frame = new ChatFrame(args[0], args[1], args[2], args[3]);
   }


   public ChatFrame(String hostname, String spacename, String channel, String user)
   {
      super("P2P Unleashed");
      JavaSpace space =  SpaceAccessor.getSpace(hostname, spacename);
      addWindowListener(new WindowEventHandler());
      getContentPane().setBackground(Color.black);
      getContentPane().add(new ChatController(this, space,
                                        channel,user).getChatView());
      setSize(480,640);
      setVisible(true);
   }

   class WindowEventHandler extends WindowAdapter {
         public void windowClosing(WindowEvent evt) {
             System.exit(0);
         }
   }
}
