import java.rmi.*;
import java.util.*;
import net.jini.space.JavaSpace;
import net.jini.core.entry.*;
import net.jini.core.lookup.*;
import net.jini.lookup.entry.*;
import net.jini.core.discovery.*;

/*
 *  The SpaceAccessor class is a utility class used to resolve the reference
 *  to the outrigger JavaSpace service
*/

public class SpaceAccessor {
   // host name running LUS and name of JavaSpace instance
   public synchronized static JavaSpace getSpace(String hostname, String name) {

      try {
          if (System.getSecurityManager() == null) {
              System.setSecurityManager(
                  new RMISecurityManager());
          }

          // unicast discovery
          LookupLocator lookup = new LookupLocator("jini://" + hostname);
          System.out.println("SpaceAccessor using locator: " + lookup);
          ServiceRegistrar registrar = lookup.getRegistrar();

          // create Name entry to match on
          Entry entries[] = { new Name(name) };

          // lookup the service in the LUS
          JavaSpace space = (JavaSpace)registrar.lookup(new
                                     ServiceTemplate(null,null,entries));

          // return the proxy
          return space;
      } catch (Exception e) {
          System.err.println(e);
      }
         return null;
   }
}
