package org.jworkplace.content;

import java.beans.*;
import java.util.ArrayList;
import javax.servlet.http.*;
import javax.servlet.*;
import net.jini.core.entry.Entry;           
import net.jini.core.lease.Lease;
import net.jini.lease.LeaseRenewalManager;
import net.jini.space.JavaSpace;           

public class MetaBean {

  private JavaSpace space;

  private LeaseRenewalManager leaseMgr;

  private int nextPosition = 0;

  private boolean processError = false;

  public MetaBean() {
     leaseMgr = new LeaseRenewalManager();
  }

  public void setSpace (JavaSpace space) {
    this.space = space;
  }

  public JavaSpace getSpace() {
    return this.space;
  }


  public synchronized MetaDataEntryBean processRequest (HttpServletRequest request) {

    this.processError = false;
    MetaDataEntry entry = new MetaDataEntry(request.getParameter ("subject"),  
                                            request.getParameter ("creator"),  
                                            request.getParameter ("publisher"),  
                                            request.getParameter ("date"),  
                                            request.getParameter ("type"), 
                                            request.getParameter ("language"),  
                                            request.getParameter ("format"), 
                                            request.getParameter ("location"), 
                                            request.getParameter ("description"));  

    MetaDataEntryBean bean = new MetaDataEntryBean();
    bean.makeLink(entry); 
    return bean;
  }

  public MetaDataEntry[] getEntries() {
      Entry entry = null;
      ArrayList list = new ArrayList();
      int position = 0;
      for(;;){
        entry = read(position++);
        if(entry == null) break; 
        list.add(entry);
      } 

      nextPosition = list.size();

      return (MetaDataEntry[])list.toArray(new MetaDataEntry[0]);
  }

  public void catalog(MetaDataEntryBean bean) {
      write((MetaDataEntry)bean.followLink());
  }

             
  public MetaDataEntry find(HttpServletRequest request) {

      MetaDataEntry template = new MetaDataEntry();

      String element = request.getParameter("subject");
      template.subject = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("creator");
      template.creator = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("publisher");
      template.publisher = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("date");
      template.date = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("type");
      template.type = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("language");
      template.language = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("format");
      template.format = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("location");
      template.location = ( (element.equals("") || element == null) ? null : element);
      element = request.getParameter("description");
      template.description = ( (element.equals("") || element == null) ? null : element);

      return (MetaDataEntry)read(template);
  }


  private synchronized void write(MetaDataEntry entry)     
  {              
      entry.position = new Integer(nextPosition);
      try { 
        Lease lease = space.write(entry, null, Lease.FOREVER);     
        nextPosition++; 
        leaseMgr.renewUntil(lease, Lease.FOREVER, null);
      } catch (Exception e) { e.printStackTrace();
                              this.processError = true;
                              nextPosition--; }
               
  }    

  private Entry read(int position)     
  {              
      Entry entry = null; 
      MetaDataEntry template = new MetaDataEntry(); 
      template.position = new Integer(position);     
      try { 
          entry = space.readIfExists(template, null, 10*1000);  
      } catch (Exception e) { e.printStackTrace();
                              this.processError = true; }
      return entry;
  }  

  private Entry read(MetaDataEntry template)     
  {              
      Entry entry = null; 
      try { 
          entry = space.read(template, null, 10*1000);     
      } catch (Exception e) { e.printStackTrace();
                              this.processError = true; }
      return entry;
        
  }                  


  public boolean getProcessError () {
    return this.processError;
  }

}






