package org.jworkplace.homeplace;

import java.io.*;
import java.rmi.*;        
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import net.jini.space.JavaSpace;           

import org.jworkplace.util.*;
import org.jworkplace.content.*;

public class HomePlace extends HttpServlet {

    private SpaceBean spaceBean;
    private static MetaBean metaBean;
    private JavaSpace space;

    private String updatePage = "/document.jsp";
    private String searchPage = "/find.jsp";
    private String listPage = "/view.jsp";
    private String errorPage = "/error.jsp";


    public void init() {
      
       System.setSecurityManager(new RMISecurityManager());

       try {
          spaceBean = new SpaceBean();
       } catch(Exception e) { e.printStackTrace(); 
                              System.exit(1); }
       try {

          space = getHomeSpace();

          metaBean = new MetaBean();
          metaBean.setSpace(space);

       } catch (InterruptedException e) {}

    }

    public void doPost(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");
      
        // default page
        String nextPage = listPage;
        String action = request.getParameter("action");

        if(action != null) {
           if(action.equals("Update"))
           { 
               MetaDataEntryBean entryBean = metaBean.processRequest(request);
               metaBean.catalog(entryBean);
               nextPage = updatePage;

           } else if( action.equals("Search")) {
               nextPage = searchPage;
           } 
        } 

        ServletContext ctx = getServletContext();
        RequestDispatcher dispatcher = ctx.getRequestDispatcher(nextPage);
        dispatcher.forward(request, response);

    }

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        doPost(request,response);
    }


    public void destroy() {}

    public JavaSpace getHomeSpace() throws InterruptedException
    {
         return spaceBean.getSpace();
    }

    public static MetaBean getMetaBean() {
         return metaBean;
    }

}



