package org.jworkplace.util;
import java.rmi.*;         
import java.io.IOException;  
import net.jini.core.entry.*;  
import net.jini.core.lookup.ServiceRegistrar;  
import net.jini.discovery.DiscoveryListener;
import net.jini.discovery.DiscoveryEvent;
import net.jini.discovery.LookupDiscovery; 
import net.jini.space.JavaSpace;           

 public class SpaceBean implements DiscoveryListener {                   
                   
    private JavaSpace space;       
    private ServiceRegistrar[] registrars;
   
    public SpaceBean() throws IOException  { 

        // start finding registrars (lookup services)
        LookupDiscovery mgt = new LookupDiscovery(LookupDiscovery.NO_GROUPS);
        mgt.addDiscoveryListener(this);
        ((LookupDiscovery)mgt).setGroups(LookupDiscovery.ALL_GROUPS);
    }  
  
    public synchronized void discovered(DiscoveryEvent de) {
       // get the array of lookup services discovered 
       registrars = de.getRegistrars();   
       findSpace(registrars);
    }      
      
    public void discarded(DiscoveryEvent de) {}      
  
    private void findSpace(ServiceRegistrar[] registrars) {
       if(space == null) {
         for(int i=0; i < registrars.length; i++) {    
            try {
               space = ServiceFinder.findSpace(registrars[i]); 
               if(space != null) {
                  System.out.println("JavaSpaces resolved to: " + space);
                  notifyAll();
                  break;
               }  
            } catch (Exception e) { e.printStackTrace(); }
         }
       }
    }

    public synchronized JavaSpace getSpace() throws InterruptedException {
       while(space == null) {
        wait();
       }
       return space; 
    }
   
}    