/*
 * 20020408
 * JxtaGui.java
 * A simple GUI for SOAP-over-P2P.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

import net.jxta.document.Advertisement;
import ch20.peer.Publisher;
import ch20.peer.Requester;


public class JxtaGui extends JFrame {


	JPanel contentPane = null;
	JLabel titleLabel = null;
	JLabel ServiceLabel = null;
	JLabel ServiceVersionLabel = null;
	JLabel ServiceCreatorLabel = null;
	JLabel ServiceDescriptionLabel = null;
	JLabel ServiceSpecURLLabel = null;
	JLabel ServiceAdvertisementFileNameLabel = null;
	
	JRadioButton clientRadioButton = null;
	JRadioButton serverRadioButton = null;
	ButtonGroup btnGroup = null;
	
	JTextField ServiceText = null;
	JTextField ServiceVersionText = null;
	JTextField ServiceCreatorText = null;
	JTextField ServiceDescriptionText = null;
	JTextField ServiceSpecURLText = null;
	JTextField ServiceAdvertisementFileNameText = null;
	
	JTextArea textArea = null;
	
	JButton button = null;

	private Publisher publisher;
	private Requester requester;

	private String ServiceName="";
	private String ServiceVersion="";
	private String ServiceCreator="";
	private String ServiceDescription="";
	private String ServiceSpecURL="";
	private String ServiceAdvertisementFileName="publisher.adv";

  
	public JxtaGui()  {
		publisher = new Publisher();
		requester = new Requester();
	
		titleLabel = new JLabel();
		ServiceLabel = new JLabel();
		ServiceVersionLabel = new JLabel();
		ServiceCreatorLabel = new JLabel();
		ServiceDescriptionLabel = new JLabel();
		ServiceSpecURLLabel = new JLabel();
		ServiceAdvertisementFileNameLabel = new JLabel();

		ServiceText = new JTextField();
		ServiceVersionText = new JTextField();
		ServiceCreatorText = new JTextField();
		ServiceDescriptionText = new JTextField();
		ServiceSpecURLText = new JTextField();
		ServiceAdvertisementFileNameText = new JTextField("publisher.adv");


		clientRadioButton = new JRadioButton();
		serverRadioButton = new JRadioButton();
		btnGroup = new ButtonGroup();
		
		
		button = new JButton();

		textArea = new JTextArea ("Message window:\r\n", 10, 40);
		publisher.setMessageReceiver(textArea);
		requester.setMessageReceiver(textArea);



		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(new FlowLayout());

		this.setSize(new Dimension(450, 425));
		this.setTitle("SOAP-over-P2P");

		clientRadioButton.setText("Requester");
		clientRadioButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				button.setText("Invoke");
				ServiceAdvertisementFileName="requester.adv";
				ServiceAdvertisementFileNameText.setText("requester.adv");
			}
		});

		serverRadioButton.setText("Publisher");
		serverRadioButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				button.setText("Publish");
				ServiceAdvertisementFileName="publisher.adv";
				ServiceAdvertisementFileNameText.setText("publisher.adv");
			}
		});

		btnGroup.add(clientRadioButton);
		btnGroup.add(serverRadioButton);

		button.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (button.getText().equals("Publish")){
					publisher.publishServiceOverJXTAPipe(
						ServiceName,
						ServiceVersion,
						ServiceDescription,
						ServiceCreator,
						ServiceSpecURL,
						ServiceAdvertisementFileName
					);

				} else if (button.getText().equals("Invoke")){
					requester.publishServiceOverJXTAPipe(
						"requester1",
						ServiceVersion,
						ServiceDescription,
						ServiceCreator,
						ServiceSpecURL,
						ServiceAdvertisementFileName
					);
					requester.createOutputPipeAndSendMessage(
					ServiceName,"requester1");
				}
			}
		});


		ServiceText.getDocument().
			addDocumentListener(new javax.swing.event.DocumentListener() {
				public void changedUpdate(DocumentEvent e) {
				}
				public void insertUpdate(DocumentEvent e) {
				ServiceName=ServiceText.getText();
				System.out.println(ServiceName+"_insert");
			}
			public void removeUpdate(DocumentEvent e) {
				ServiceName=ServiceText.getText();
				System.out.println(ServiceName+"_remove");
			}
		});

		ServiceVersionText.getDocument().
			addDocumentListener(new javax.swing.event.DocumentListener() {
				public void changedUpdate(DocumentEvent e) {
				}
				public void insertUpdate(DocumentEvent e) {
				ServiceVersion=ServiceVersionText.getText();
				System.out.println(ServiceVersion+"_insert");
			}
			public void removeUpdate(DocumentEvent e) {
				ServiceVersion=ServiceVersionText.getText();
				System.out.println(ServiceVersion+"_remove");
			}
		});

		ServiceCreatorText.getDocument().
			addDocumentListener(new javax.swing.event.DocumentListener() {
				public void changedUpdate(DocumentEvent e) {
				}
				public void insertUpdate(DocumentEvent e) {
				ServiceCreator=ServiceCreatorText.getText();
				System.out.println(ServiceCreator+"_insert");
			}
			public void removeUpdate(DocumentEvent e) {
				ServiceCreator=ServiceCreatorText.getText();
				System.out.println(ServiceCreator+"_remove");
			}
		});

		ServiceDescriptionText.getDocument().
			addDocumentListener(new javax.swing.event.DocumentListener() {
				public void changedUpdate(DocumentEvent e) {
				}
				public void insertUpdate(DocumentEvent e) {
				ServiceDescription=ServiceDescriptionText.getText();
				System.out.println(ServiceDescription+"_insert");
			}
			public void removeUpdate(DocumentEvent e) {
				ServiceDescription=ServiceDescriptionText.getText();
				System.out.println(ServiceDescription+"_remove");
			}
		});

		ServiceSpecURLText.getDocument().
			addDocumentListener(new javax.swing.event.DocumentListener() {
				public void changedUpdate(DocumentEvent e) {
				}
				public void insertUpdate(DocumentEvent e) {
				ServiceSpecURL=ServiceSpecURLText.getText();
				System.out.println(ServiceSpecURL+"_insert");
			}
			public void removeUpdate(DocumentEvent e) {
				ServiceSpecURL=ServiceSpecURLText.getText();
				System.out.println(ServiceSpecURL+"_remove");
			}
		});

		ServiceAdvertisementFileNameText.getDocument().
			addDocumentListener(new javax.swing.event.DocumentListener() {
				public void changedUpdate(DocumentEvent e) {
				}
				public void insertUpdate(DocumentEvent e) {
				ServiceAdvertisementFileName=ServiceAdvertisementFileNameText.getText();
				System.out.println(ServiceAdvertisementFileName+"_insert");
			}
			public void removeUpdate(DocumentEvent e) {
				ServiceAdvertisementFileName=ServiceAdvertisementFileNameText.getText();
				System.out.println(ServiceAdvertisementFileName+"_remove");
			}
		});

		titleLabel.setFont(new java.awt.Font("Dialog", 1, 12));
		titleLabel.setText("Select The Peer Mode                                         ");

		ServiceText.setColumns(20);
		ServiceLabel.setText("Service Name                                      :");
		ServiceVersionText.setColumns(20);
		ServiceVersionLabel.setText("Service Version                                 :");
		ServiceCreatorText.setColumns(20);
		ServiceCreatorLabel.setText("Service Creator                                  :");
		ServiceDescriptionText.setColumns(20);
		ServiceDescriptionLabel.setText("Service DescriptionName                :");
		ServiceSpecURLText.setColumns(20);
		ServiceSpecURLLabel.setText("Service SpecURLName                     :");
		ServiceAdvertisementFileNameText.setColumns(20);
		ServiceAdvertisementFileNameLabel.setText("Service Advertisement File Name :");



		button.setText("Invoke");

		contentPane.add(new JLabel("                                       "));
		contentPane.add(titleLabel);
		contentPane.add(new JLabel("                  "));
		contentPane.add(clientRadioButton);
		contentPane.add(new JLabel("               "));
		contentPane.add(serverRadioButton);
		contentPane.add(new JLabel("                                                   "));
		contentPane.add(ServiceLabel);
		contentPane.add(ServiceText);
		contentPane.add(ServiceVersionLabel);
		contentPane.add(ServiceVersionText);
		contentPane.add(ServiceCreatorLabel);
		contentPane.add(ServiceCreatorText);
		contentPane.add(ServiceDescriptionLabel);
		contentPane.add(ServiceDescriptionText);
		contentPane.add(ServiceSpecURLLabel);
		contentPane.add(ServiceSpecURLText);
		contentPane.add(ServiceAdvertisementFileNameLabel);
		contentPane.add(ServiceAdvertisementFileNameText);


		contentPane.add(button);
		contentPane.add(new JLabel("                                  "));
		contentPane.add(new JScrollPane(textArea));
		this.setVisible(true);
	}//constructor

	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}

	public static void main (String args[]) {
		JxtaGui app = new JxtaGui();
	}
}//class